<template>
  <div class="user-info">
    <div class="left">
      <div>
        <img class="header-img" :src="userInfo.Img" :onerror="errorImg" />
        <div class="text">
          <p class="name">
            <span>{{userInfo.UserName}}</span>
          </p>
          <p class="date">
            <span>注册日期：{{userInfo.CreateDate}}</span>
          </p>
          <!-- <p>
            <Button style="padding: 3px 16px;" type="info" size="small" ghost>修改头像</Button>
          </p>-->
        </div>
      </div>
      <div style="padding: 17px;">
        <Button type="error" @click="modifyPwd" size="large" icon="md-lock" long>修改密码</Button>
      </div>
    </div>
    <div class="right">
      <vol-form
        ref="form"
        :load-key="true"
        :width="500"
        :formRules="editFormOptions"
        :formFileds="editFormFileds"
      >
        <div slot="header">
          <Divider>
            <span class="ivu-icon ios-alert-outline">个人信息</span>
          </Divider>
        </div>
        <div slot="footer">
          <Button
            style="margin-top: 2px;"
            type="info"
            size="large"
            icon="md-checkmark-circle"
            long
            @click="modifyInfo"
          >保存</Button>
        </div>
      </vol-form>
    </div>
    <VolBox
      :width="500"
      :height="260"
      :footer="false"
      :model.sync="modifyOptions.model"
      title="修改密码"
    >
      <div style="padding:10px 20px;">
        <VolForm ref="pwd" :formRules="modifyOptions.data" :formFileds="modifyOptions.fileds"></VolForm>
        <Button type="info" size="large" icon="md-checkmark-circle" long @click="savePwd">保存</Button>
      </div>
      <div slot="footer">
        <span></span>
      </div>
    </VolBox>
  </div>
</template>
<script>
import VolForm from "@/components/basic/VolForm.vue";
export default {
  components: {
    VolForm: VolForm,
    VolBox: () => import("@/components/basic/VolBox.vue"),
  },
  methods: {
    modifyPwd() {
      this.$refs.pwd.reset();
      this.modifyOptions.model = true;
    },
    savePwd() {
      if (!this.$refs.pwd.validate()) return;
      if (
        this.modifyOptions.fileds.newPwd != this.modifyOptions.fileds.newPwd1
      ) {
        return this.$message.error("两次密码不一致");
      }
      let url =
        "/api/user/modifyPwd?oldPwd=" +
        this.modifyOptions.fileds.oldPwd +
        "&newPwd=" +
        this.modifyOptions.fileds.newPwd;
      this.http.post(url, {}, true).then((x) => {
        if (!x.status) {
          return this.$message.error(x.message);
        }
        this.modifyOptions.model = false;
        this.$Message.success(x.message);
        this.$refs.pwd.reset();
      });
    },
    modifyInfo() {
      let url = "/api/Sys_User/update";
      //将key首字母转成大写
      //let result = this.editFormFileds;
      // for (var key in result) {
      //   result[key.substring(0, 1).toUpperCase() + key.substring(1)] =
      //     result[key];
      //   delete result[key];
      // }
      //console.log(result);
      let formData = {
        mainData: this.editFormFileds,
        detailData: null,
        delKeys: null,
      };
      this.http.post(url, formData, true).then((x) => {
        if (!x.status) {
          return this.$message.error(x.message);
        }
        this.$Message.success(x.message);
      });
    },
  },
  created() {
    this.http.post("/api/user/getCurrentUserInfo", {}, true).then((x) => {
      if (!x.status) {
        return this.$message(x.message);
      }
      x.data.createDate = (x.data.createDate || "").replace("T", " ");
      x.data.gender = x.data.gender + "";
      //this.$refs.form.reset(x.data);
      this.editFormFileds.UserTrueName = x.data.userTrueName;
      this.editFormFileds.PhoneNo = x.data.phoneNo;
      this.editFormFileds.User_Id = x.data.user_Id;
      this.editFormFileds.Role_Id = x.data.role_Id;
      this.editFormFileds.Address = x.data.address;
      this.editFormFileds.UserName = x.data.userName;
      this.editFormFileds.RoleName = x.data.roleName;

      this.userInfo.Img = this.base.getImgSrc(
        x.data.headImageUrl,
        this.http.ipAddress
      );
      this.userInfo.CreateDate = x.data.createDate;
      this.userInfo.UserName = x.data.userTrueName;
      this.userInfo.PhoneNo = x.data.phoneNo;
      this.userInfo.User_Id = x.data.user_Id;
      this.userInfo.Role_Id = x.data.role_Id;
      // this.editFormFileds = x.data;
    });
  },
  data() {
    return {
      url: "/api/App_Appointment/Upload",
      errorImg: 'this.src="' + require("@/assets/imgs/error-img.png") + '"',
      modifyOptions: {
        model: false,
        fileds: { oldPwd: "", newPwd: "", newPwd1: "" },
        data: [
          [
            {
              columnType: "string",
              required: true,
              title: "旧密码",
              field: "oldPwd",
            },
          ],
          [
            {
              type: "password",
              required: true,
              title: "新密码",
              field: "newPwd",
            },
          ],
          [
            {
              type: "password",
              required: true,
              title: "确认密码",
              field: "newPwd1",
            },
          ],
        ],
      },
      binging: [{}],
      userInfo: {
        Img: "",
        CreateDate: "--",
        UserName: "--",
        Email: "",
        PhoneNo: "",
        User_Id: "",
        Role_Id: "",
      },
      editFormFileds: {
        User_Id: "",
        Role_Id: "",
        RoleName: "",
        UserName: "",
        UserTrueName: "",
        PhoneNo: "",
        Address: "",
      },
      editFormOptions: [
        [
          {
            columnType: "string",
            title: "用户名",
            field: "UserName",
            disabled: true,
            type: "text",
          },
        ],
        [
          {
            columnType: "string",
            title: "角色",
            field: "RoleName",
            disabled: true,
            type: "text",
          },
        ],
        [
          {
            columnType: "string",
            title: "真实姓名",
            field: "UserTrueName",
            disabled: true,
            type: "text",
          },
        ],
        [
          {
            columnType: "string",
            title: "手机号码",
            field: "PhoneNo",
            type: "text",
          },
        ],
        [
          {
            columnType: "string",
            title: "地址",
            field: "Address",
            type: "text",
          },
        ],
      ],
    };
  },
};
</script>
<style scoped>
.binding-group {
  width: 100%;
  padding-bottom: 20px;
}
.binding-group >>> .ivu-cell-link {
  text-align: left;
}
.binding-group >>> .ivu-card-body {
  padding: 0 16px;
}
.binding-group >>> .ivu-cell-title {
  line-height: 24px;
  font-size: 12px;
}
</style>

<style lang="less" scoped>
img[src=""],
img:not([src]) {
  opacity: 0;
}
.user-info {
  box-shadow: rgb(214, 214, 214) 0px 4px 21px;
  position: absolute;
  transform: translateY(-40%);
  top: 40%;
  position: relative;
  margin: 0 auto;
  left: 0;
  width: 895px;
  right: 0;
  text-align: center;
  padding: 0px;
  //display: flex;
  .text {
    padding: 5px;
    .name {
      font-weight: bolder;
      font-size: 15px;
      font-weight: 900;
    }
    > p {
      padding-top: 5px;
    }
  }
  .header-img {
    height: 150px;
    width: 150px;
    border-radius: 50%;
    margin-right: 0px;
    top: 4px;
    position: relative;
    border: 3px solid #dfdfdf;
  }
  > div {
    float: left;
    // height: 480px;
    padding-top: 10px;
  }
  .left {
    width: 320px;
    border-right: 1px solid #eee;
    // box-shadow: #d6d6d6 7px 4px 20px;
    // flex: 1;
  }
  .right {
    padding-left: 30px;
    width: 570px;
    // background: #fefefe;
    // flex: 3;
  }
}
</style>


